org.apache.lucene.search

## Class IndexSearcher

- java.lang.Object
- - org.apache.lucene.search.Searcher
  - - org.apache.lucene.search.IndexSearcher

- All Implemented Interfaces:
    Searchable

      public class IndexSearcher
      extends Searcher

  Implements search over a single IndexReader.

  Applications usually need only call the inherited `Searcher.search(Query,int)` or `Searcher.search(Query,Filter,int)` methods. For performance reasons it is recommended to open only one IndexSearcher and use it for all of your searches.

  Note that you can only access the deprecated `Hits` from an IndexSearcher as long as it is not yet closed, otherwise an IOException will be thrown.

  NOTE: `IndexSearcher` instances are completely thread safe, meaning multiple threads can call any of its methods, concurrently. If your application requires external synchronization, you should not synchronize on the `IndexSearcher` instance; use your own (non-Lucene) objects instead.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `IndexSearcher(Directory directory)` Deprecated. Use `IndexSearcher(Directory, boolean)` instead
    `IndexSearcher(Directory path, boolean readOnly)` Creates a searcher searching the index in the named directory.
    `IndexSearcher(IndexReader r)` Creates a searcher searching the provided index.
    `IndexSearcher(java.lang.String path)` Deprecated. Use `IndexSearcher(Directory, boolean)` instead
    `IndexSearcher(java.lang.String path, boolean readOnly)` Deprecated. Use `IndexSearcher(Directory, boolean)` instead

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Note that the underlying IndexReader is not closed, if IndexSearcher was constructed with IndexSearcher(IndexReader r).
    `Document` | `doc(int i)` Returns the stored fields of document `i`.
    `Document` | `doc(int i, FieldSelector fieldSelector)` Get the `Document` at the `n`th position.
    `int` | `docFreq(Term term)` Expert: Returns the number of documents containing `term`.
    `Explanation` | `explain(Weight weight, int doc)` Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.
    `protected void` | `gatherSubReaders(java.util.List allSubReaders, IndexReader r)`
    `IndexReader` | `getIndexReader()` Return the `IndexReader` this searches.
    `int` | `maxDoc()` Expert: Returns one greater than the largest possible document number.
    `Query` | `rewrite(Query original)` Expert: called to re-write queries into primitive queries.
    `void` | `search(Weight weight, Filter filter, Collector collector)` Lower-level search API.
    `TopDocs` | `search(Weight weight, Filter filter, int nDocs)` Expert: Low-level search implementation.
    `TopFieldDocs` | `search(Weight weight, Filter filter, int nDocs, Sort sort)` Expert: Low-level search implementation with arbitrary sorting.
    `TopFieldDocs` | `search(Weight weight, Filter filter, int nDocs, Sort sort, boolean fillFields)` Just like `search(Weight, Filter, int, Sort)`, but you choose whether or not the fields in the returned `FieldDoc` instances should be set by specifying fillFields.
    `void` | `setDefaultFieldSortScoring(boolean doTrackScores, boolean doMaxScore)` By default, no scores are computed when sorting by field (using `Searcher.search(Query,Filter,int,Sort)`).

    - ### Methods inherited from class org.apache.lucene.search.Searcher

      `createWeight, docFreqs, explain, getSimilarity, search, search, search, search, search, search, search, search, search, search, search, search, setSimilarity`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### IndexSearcher

          public IndexSearcher(java.lang.String path)
                        throws CorruptIndexException,
                               java.io.IOException

      Deprecated. Use `IndexSearcher(Directory, boolean)` instead
      Creates a searcher searching the index in the named directory.
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### IndexSearcher

          public IndexSearcher(java.lang.String path,
                               boolean readOnly)
                        throws CorruptIndexException,
                               java.io.IOException

      Deprecated. Use `IndexSearcher(Directory, boolean)` instead
      Creates a searcher searching the index in the named directory. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the underlying IndexReader.
      Parameters:
        `path` - directory where IndexReader will be opened
        `readOnly` - if true, the underlying IndexReader will be opened readOnly
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### IndexSearcher

          public IndexSearcher(Directory directory)
                        throws CorruptIndexException,
                               java.io.IOException

      Deprecated. Use `IndexSearcher(Directory, boolean)` instead
      Creates a searcher searching the index in the provided directory.
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### IndexSearcher

          public IndexSearcher(Directory path,
                               boolean readOnly)
                        throws CorruptIndexException,
                               java.io.IOException

      Creates a searcher searching the index in the named directory. You should pass readOnly=true, since it gives much better concurrent performance, unless you intend to do write operations (delete documents or change norms) with the underlying IndexReader.
      Parameters:
        `path` - directory where IndexReader will be opened
        `readOnly` - if true, the underlying IndexReader will be opened readOnly
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### IndexSearcher

          public IndexSearcher(IndexReader r)

      Creates a searcher searching the provided index.

  - ### Method Detail

    - #### gatherSubReaders

          protected void gatherSubReaders(java.util.List allSubReaders,
                                          IndexReader r)

    - #### getIndexReader

          public IndexReader getIndexReader()

      Return the `IndexReader` this searches.

    - #### close

          public void close()
                     throws java.io.IOException

      Note that the underlying IndexReader is not closed, if IndexSearcher was constructed with IndexSearcher(IndexReader r). If the IndexReader was supplied implicitly by specifying a directory, then the IndexReader gets closed.
      Specified by:
        `close` in interface `Searchable`
      Specified by:
        `close` in class `Searcher`
      Throws:
        `java.io.IOException`

    - #### docFreq

          public int docFreq(Term term)
                      throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Returns the number of documents containing `term`.
      Specified by:
        `docFreq` in interface `Searchable`
      Specified by:
        `docFreq` in class `Searcher`
      Throws:
        `java.io.IOException`
      See Also:
        `IndexReader.docFreq(Term)`

    - #### doc

          public Document doc(int i)
                       throws CorruptIndexException,
                              java.io.IOException

      Description copied from interface: `Searchable`
      Returns the stored fields of document `i`.
      Specified by:
        `doc` in interface `Searchable`
      Specified by:
        `doc` in class `Searcher`
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `IndexReader.document(int)`

    - #### doc

          public Document doc(int i,
                              FieldSelector fieldSelector)
                       throws CorruptIndexException,
                              java.io.IOException

      Description copied from interface: `Searchable`
      Get the `Document` at the `n`th position. The `FieldSelector` may be used to determine what `Field`s to load and how they should be loaded. NOTE: If the underlying Reader (more specifically, the underlying `FieldsReader`) is closed before the lazy `Field` is loaded an exception may be thrown. If you want the value of a lazy `Field` to be available after closing you must explicitly load it or fetch the Document again with a new loader.
      Parameters:
        `i` - Get the document at the `n`th position
        `fieldSelector` - The `FieldSelector` to use to determine what Fields should be loaded on the Document. May be null, in which case all Fields will be loaded.
      Returns:
        The stored fields of the `Document` at the nth position
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `IndexReader.document(int, FieldSelector)`, `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

    - #### maxDoc

          public int maxDoc()
                     throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Returns one greater than the largest possible document number.
      Specified by:
        `maxDoc` in interface `Searchable`
      Specified by:
        `maxDoc` in class `Searcher`
      Throws:
        `java.io.IOException`
      See Also:
        `IndexReader.maxDoc()`

    - #### search

          public TopDocs search(Weight weight,
                                Filter filter,
                                int nDocs)
                         throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Low-level search implementation. Finds the top `n` hits for `query`, applying `filter` if non-null.

      Applications should usually call `Searcher.search(Query)` or `Searcher.search(Query,Filter)` instead.

      Specified by:
        `search` in interface `Searchable`
      Specified by:
        `search` in class `Searcher`
      Throws:
        `java.io.IOException`

    - #### search

          public TopFieldDocs search(Weight weight,
                                     Filter filter,
                                     int nDocs,
                                     Sort sort)
                              throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: Low-level search implementation with arbitrary sorting. Finds the top `n` hits for `query`, applying `filter` if non-null, and sorting the hits by the criteria in `sort`.

      Applications should usually call `Searcher.search(Query,Filter,int,Sort)` instead.

      Specified by:
        `search` in interface `Searchable`
      Specified by:
        `search` in class `Searcher`
      Throws:
        `java.io.IOException`

    - #### search

          public TopFieldDocs search(Weight weight,
                                     Filter filter,
                                     int nDocs,
                                     Sort sort,
                                     boolean fillFields)
                              throws java.io.IOException

      Just like `search(Weight, Filter, int, Sort)`, but you choose whether or not the fields in the returned `FieldDoc` instances should be set by specifying fillFields.

      NOTE: this does not compute scores by default. If you need scores, create a `TopFieldCollector` instance by calling `TopFieldCollector.create(org.apache.lucene.search.Sort, int, boolean, boolean, boolean, boolean)` and then pass that to `search(Weight, Filter, Collector)`.

      Throws:
        `java.io.IOException`

    - #### search

          public void search(Weight weight,
                             Filter filter,
                             Collector collector)
                      throws java.io.IOException

      Description copied from interface: `Searchable`
      Lower-level search API.

      `Collector.collect(int)` is called for every document.
      Collector-based access to remote indexes is discouraged.

      Applications should only use this if they need all of the matching documents. The high-level search API (`Searcher.search(Query)`) is usually more efficient, as it skips non-high-scoring hits.

      Specified by:
        `search` in interface `Searchable`
      Specified by:
        `search` in class `Searcher`
      Parameters:
        `weight` - to match documents
        `filter` - if non-null, used to permit documents to be collected.
        `collector` - to receive hits
      Throws:
        `java.io.IOException`

    - #### rewrite

          public Query rewrite(Query original)
                        throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: called to re-write queries into primitive queries.
      Specified by:
        `rewrite` in interface `Searchable`
      Specified by:
        `rewrite` in class `Searcher`
      Throws:
        `java.io.IOException`

    - #### explain

          public Explanation explain(Weight weight,
                                     int doc)
                              throws java.io.IOException

      Description copied from interface: `Searchable`
      Expert: low-level implementation method Returns an Explanation that describes how `doc` scored against `weight`.

      This is intended to be used in developing Similarity implementations, and, for good performance, should not be displayed with every hit. Computing an explanation is as expensive as executing the query over the entire index.

      Applications should call `Searcher.explain(Query, int)`.

      Specified by:
        `explain` in interface `Searchable`
      Specified by:
        `explain` in class `Searcher`
      Throws:
        `java.io.IOException`

    - #### setDefaultFieldSortScoring

          public void setDefaultFieldSortScoring(boolean doTrackScores,
                                                 boolean doMaxScore)

      By default, no scores are computed when sorting by field (using `Searcher.search(Query,Filter,int,Sort)`). You can change that, per IndexSearcher instance, by calling this method. Note that this will incur a CPU cost.
      Parameters:
        `doTrackScores` - If true, then scores are returned for every matching document in `TopFieldDocs`.
        `doMaxScore` - If true, then the max score for all matching docs is computed.

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.